#include <pthread.h>
#include <unistd.h>
#include <signal.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "core/interface/wmp_interface.h"
#include "core/include/nstat.h"
#include "core/include/wmp_misc.h"
#include "core/interface/Msg.h"
#include "extensions/broadcast/interface/wmp_bc_interface.h"

/*Drivers de marte*/
#include "../drivers/p2os-marte/p2os.h"
#include "../drivers/p2os-marte/p2os.c"

#include <../drivers/laser-marte/laser.c>
#include <drivers/laser_types.h>

#include <misc/console_management.h>
#include <sys/pio.h>
#include <intr.h>
/*Code*/

void  INThandler(int sig){
	exit(0);
}

int msgSize=512;

void wmpSIGINT(int n){
	wmpExit();
	exit(0);
}
void iniciaLaser(){
	//inicializa laser	
//  uchar buf[MAXNDATA];
  char defaultdev[]="/dev/ttyS2", *port=defaultdev;
//  int datalen,count=0,count_max=100;
  int range_mode=RANGE_100,res_mode=RES_1_DEG,unit_mode=MMMODE;
  int baud_sel=BAUD_19200;//BAUD_38400;//BAUD_19200;// BAUD_9600;
  
  connectToLMS(range_mode, res_mode, unit_mode, port, baud_sel);
  printf("Laser inicializado\n"); get_char();
}
void *actualiza_laser(void * kkk){
	int datalen;
	while(1){
		datalen = readLMSValues();
		printf("Puntos %d\n",GetCountLaser());
	}
//  vaciarlaser();
//  stopLMS();
//  put_line("Paramos el laser");
//  resetLMS();
//  put_line("Reseteamos el laser"
} 
  
void iniciaP2os(){
  printf("P2OS:   Empieza la inicializacion\n"); 
  initP2os("/dev/ttyS0");
  //get_char();
  printf("P2OS inicializado\n");get_char();
} 
void *actualiza_p2os(void * kkk){
	while(1){
		SendReceive(NULL,0);	
	}
} 

void pinta_marco(){ 
int I;
set_text_color(YELLOW);
	clrscr();
//------------------------------------------------
//--- MARCO PRINCIPAL
//------------------------------------------------
	set_cursorxy(1,1);
	for( I= 1; I < 78; I++)	printf("_");	

	set_cursorxy(23,1);
	for( I= 1; I < 78; I++) printf("_");
	
	for( I= 1; I < 23; I++) {set_cursorxy(I,1);printf("|");}

	for( I= 1; I < 23; I++) {set_cursorxy(I,78);printf("|");}
//------------------------------------------------
//--- OTROS 
//------------------------------------------------	
	for( I= 1; I < 15; I++) {set_cursorxy(I,52);printf("|");}
	
	//for( I= 1; I < 23; I++) {set_cursorxy(15,54); printf("");}
	set_cursorxy(15,1);
	for( I= 1; I < 78; I++) printf("_");
}


void visualiza(Msg *m){
	int laserValor;
	int cnt =1;
	int columna=1;
	
	pinta_marco();
	
	int * val = (int *)&m->data[1];
	//int nval = *val;
	//posicion
	set_cursorxy(3,54); printf("Posicion:");
	set_cursorxy(5,54); printf("x = %d",*val); val++;
	set_cursorxy(6,54); printf("y = %d",*val); val++; 
	set_cursorxy(7,54); printf("rot = %d",*val); val++;
	
	//velocidad
	//set_cursor(9,54); Put("XSpeed = "); Put (Rvel,1); Put(" YawSpeed = "); Put (Lvel,1);
	set_cursorxy(9,54); printf("Velocidad:");
	set_cursorxy(11,54); printf("trans = %d",*val); val++;
	set_cursorxy(12,54); printf("ang = %d",*val); val++;
   //laser
   	int nval = *val;
	set_cursorxy(13,54); printf("PTOS = %d",*val);
	
	
	int I;
// visualizamos el laesr 
//	int * val = (int *)&m->data[6];

	//printf("NVAL = %d\n",nval);
	while (cnt < nval) {		        
		laserValor=((*(val+cnt) + *(val+cnt+1))/2) /500;
		//printf("laserValor = %d\n",laserValor);
		//(m->data[6+cnt] + m->data[6+cnt+1])/2) /500; 
		cnt = cnt + 2;
		
		if (laserValor > 14) laserValor=14;
		
		for (I=1; I<laserValor;I++){
	  		set_cursorxy(I+1,columna+1); 
			printf("*");
		}
		columna=columna+1;
	}
	cnt=1;
	columna=1;
	
	
	set_cursorxy(16,20); printf("MOVIMIENTO");
	set_cursorxy(17,20); printf("FLECHA ARRIBA");  printf("     q: +vtrans"); printf("     w: +vrot");
	set_cursorxy(18,15); printf("FLECHA IZQ"); printf("   FLECHA DCHA");
	set_cursorxy(19,20); printf("FLECHA ABAJO");   printf("     a: -vtrans"); printf("     s: -vtrans");
    
	
	
//	set_cursorxy(14,54); printf("D1 = %d",*val); 
		//printf("ODOMETRIA  x=%d | y=%d | a=%d\n",m.data[1],m.data[2],m.data[3]);

}

void *fthread (void * kkk){
	int idx=0;
	sleep(3);			
	fprintf(stderr,"After\n");
	int idxx=0;
	struct timespec ts;
      double newspeed = 0.0;
      double newturnrate = 0.0;
      double speedtrans = 0.3;
      double speedrot = 0.2;
      int primeravez = 1;
	while (1){
		if (wmpGetNodeId()== 0){ //robot
			Msg m;				
			if (wmpGetNumOfElementInRXUCQueue()){
	
			//m.dest= 1;//nodo del ordenador	
			wmpPopUCMsg(&m);	
			
			newspeed = 0.0;
			newturnrate = 0.0;
			//char * val = (int *)&m.data[0];
			if (m.data[0] == '8'){
				printf("Hacia delante\n");
				newspeed = speedtrans;
				newturnrate=0.0;
				
			}	
			else if (m.data[0] == '2'){
				printf("Hacia atras \n");
				newspeed = -speedtrans;
				newturnrate=0.0;
				
			}	
		    else if (m.data[0] == '4'){
				printf("Hacia izq\n");
				newspeed = 0.0;
				newturnrate=speedrot;
				
			}	
			else if (m.data[0] == '6'){
				printf("Hacia derecha\n");
				newspeed = 0.0;
				newturnrate= -speedrot;				
			}	
			else if (m.data[0] == 'q'){
				printf("+ velocidad translacion\n");
				if (speedtrans < 2.0)
				speedtrans+=0.1;			
			}	
			else if (m.data[0] == 'a'){
				printf("- velocidad translacion\n");
				if (speedtrans > 0.0)
				speedtrans-=0.1;			
			}	
			else if (m.data[0] == 'w'){
				printf("+ velocidad rotacion\n");
				if (speedrot < 2.0)
				speedrot+=0.1;			
			}	
			else if (m.data[0] == 's'){
				printf("- velocidad rotacion\n");
				if (speedrot > 0.0)
				speedrot-=0.1;			
			}
			
			SetSpeed(newspeed,newturnrate);	
					
		}			
		//se crea un mensaje
			int * val = (int *)&m.data[1];
			*val = (int)(p2osGetXpos()*1000.0);val++;				
			*val =	(int)(p2osGetYpos()*1000.0);val++;
			*val =	(int)(p2osGetAngle()*1000.0);val++;
			*val =	(int)(p2osGetXSpeed()*1000.0);val++;
			*val =	(int)(p2osGetYawSpeed()*1000.0);val++;
			
			//enviamos tambien la información del laser
			//rellenamos el vector bloqueando y desbloqueando
			int I;
			// en la posicion 6 estara el numero de medidas
			*val=(int)GetCountLaser();val++;
			
			lockLaser();
			for (I=1; I< GetCountLaser();I++){				
				*val = (int)laserazo(I);		
				val++;		
			}
			unlockLaser();
			
			//printf("ODOMETRIA  x=%d | y=%d | a=%d\n",m.data[1],m.data[2],m.data[3]);
			m.len= 200*4;
			m.src=wmpGetNodeId();
			m.dest=1;//nodo del ordenador
			wmpPushUCMsg(&m);
			
			//meto un retardo para no sobregargar
			ts.tv_sec = 0;
    		ts.tv_nsec = 100*1000*1000;
    		nanosleep (&ts, NULL);		
			
		}else if (wmpGetNodeId() ==1){//ordenador
			
			Msg m;			
			char c;
			int val=0;
			
			///ENVIO!!!!!!!!!
			//Crea un mensaje si pulsa alguien una tecla
			m.data[0]=keyboard_trygetchar();
			//printf("devuelve = %d\n",(int)m.data[0]);
			if((int)m.data[0] != -1){
			//printf("LEIDO = %c\n",m.data[0]);
			//if (m.data[0] == 'p') exit(0);
			m.len=10;
			m.src=wmpGetNodeId();
			m.dest=0;//nodo del robot
			wmpPushUCMsg(&m);
			}
			///RECEPCION!!!!!!!!!
			//Mira el mensaje que llega con la odometria
			if (wmpGetNumOfElementInRXUCQueue()){
			Msg m;		
			//m.dest= 1;//nodo del ordenador	
			wmpPopUCMsg(&m);
			
			visualiza(&m);	
			
//			ts.tv_sec = 0;
//    		ts.tv_nsec = 1000*1000*1000;
//    		nanosleep (&ts, NULL);
			}
		}else printf(stderr,"Error, el nodo no es de nadie!");	
		
	}  
	
}
//	int printer_port_interrupt_handler(void * area, intr_t intr);
//	void printer_port_configure ();
	
void wmpPluginStart(){
	pthread_t thread_principal;
	pthread_create(&thread_principal,NULL,fthread,NULL);
}

void sighand(int n){
	wmpExit();
	exit(0);
}


///*
// * Printer Port related stuff
// */
//   
//// Printer Port Registers
//#define PP_BASE_REG    0x378
//#define PP_DATA_REG    0     // Data port offset
//#define PP_STATUS_REG  1     // Status port offset
//#define PP_CONTROL_REG 2     // Control port offset
//
//// Control bits
//#define PP_IENABLE 0x10  // Enable interrupt (disabled by default).
//
//// stored data
//volatile char pp_data;
//
//// printer port interrupt handler
//int printer_port_interrupt_handler(void * area, intr_t intr)
//{
// // printf ("In printer_port_interrupt_handler (intr:%d)\n", intr);
//  //pp_data = inb_p (PP_BASE_REG + PP_DATA_REG);
//  return POSIX_INTR_HANDLED_NOTIFY;
//}
//
//// printer_port_configure
//void printer_port_configure ()
//{
//  printf ("Configuring PP\n");
//  // Install interrupt handler
//  if (posix_intr_associate (7, printer_port_interrupt_handler, NULL, 0)){
//    perror ("ERRRRRRRRRRRRRRRRRRRRRRRR posix_intr_associate");
//  }
//      get_char();
//  //  Enable printer port interrupt
////  outb_p (PP_BASE_REG + PP_CONTROL_REG, PP_IENABLE);
////  //  Enable the interrupt in the computer
// // if (posix_intr_unlock (7))
////    perror ("posix_intr_unlock");
//////    posix_intr_lock(7);
//}


int main(int argc, char* argv[]){	

int Nodos = -1;
int Nodo;
printf("Numero de nodo: \n");
scanf("%d",&Nodos);


printf("nodos leidos %d",Nodos);
if(Nodos == 0){
 
  iniciaLaser();
  pthread_t thread;	
  pthread_create(&thread,NULL,actualiza_laser,NULL);
  
  iniciaP2os();
  pthread_t thread2;	
  pthread_create(&thread2,NULL,actualiza_p2os,NULL);

}
  
	wmpRun(Nodos,2,1);


	return 0;
}

