---------------------------------------------------------------------
-- Fichero:   indep.adb
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.1 14-3-2003
-- Proposito: Ejemplo con 3 tareas independientes
---------------------------------------------------------------------
-- v2.1  14-3-2003  JDT
--    Se usa Ada.Real_Time en lugar de Calendar
---------------------------------------------------------------------

with MaRTE_OS;

with Ada.Real_Time, acciones, traza, system,text_io; 
use  Ada.Real_Time, acciones, traza, text_io;
procedure apartado1 is

 Package Duracion is new Text_IO.Fixed_IO(duration);
 use Duracion;

tinicio : constant time := clock ;
intervalo : constant Time_Span:= milliseconds(10000) ;

	procedure indep is
	
	t1_prioridad: constant system.any_priority:= 3;  -- poner lo adecuado
	t2_prioridad: constant system.any_priority:= 2;  -- poner lo adecuado
	t3_prioridad: constant system.any_priority:= 1;  -- poner lo adecuado
		
	
	task T1 is pragma priority (t1_prioridad); end ;
	task body T1 is
	PERIODO : constant Time_Span:= milliseconds(1000) ;
	SIGUIENTE : time := tinicio;
	begin
	loop
	ejecuto(1);
	ACCION1 ;
	termino(1);
	SIGUIENTE := SIGUIENTE + PERIODO ;
	delay until SIGUIENTE ;
	end loop ;
	end T1 ;
	
	task T2 is pragma priority (t2_prioridad) ; end ;
	task body T2 is
	PERIODO : constant Time_Span:= milliseconds(1500) ;
	SIGUIENTE : time := tinicio;
	begin
	loop
	ejecuto(2);
	ACCION2 ;
	termino(2);
	SIGUIENTE := SIGUIENTE + PERIODO ;
	delay until SIGUIENTE ;
	end loop ;
	end T2 ;
	
	task T3 is pragma priority (t3_prioridad) ; end ;
	task body T3 is
	PERIODO : constant Time_Span:= milliseconds(3500) ;
	SIGUIENTE : time:= tinicio;
	begin
	loop
	ejecuto(3);
	ACCION3 ;
	termino(3);
	SIGUIENTE := SIGUIENTE + PERIODO;
	delay until SIGUIENTE ;
	end loop ;
	end T3 ;
	
	begin

	delay until(tinicio+intervalo);
	abort T1, T2, T3;
		
	end indep;
begin
comienzo_traza(clock);
indep;
escribe_traza(1.0); 
end apartado1;