#include <stdio.h>
#include <sys/pci.h>

void show_pci_config_space(unsigned int bus, unsigned int device_fn)
{
    int i;
    unsigned int val;

    for(i=0; i<64; i++) {
        pcibios_read_config_dword(bus, device_fn, i*4, &val);
        printf("%08X ", val);
        if ((i+1)%4 == 0) printf("\n");
    }
}
