
with Ada.Unchecked_Conversion;
with Text_IO;     use Text_IO;
with Ada.Integer_Text_IO;     use Ada.Integer_Text_IO;
with Ada.Float_Text_IO;     use Ada.Float_Text_IO;

with MaRTE_OS;
with laser_import; use laser_import;

with Interfaces.C;


procedure test_laser_ada is

package C renames Interfaces.C;
          use type C.char_array;
	  use type C.unsigned_char;

  buf: C.char_array(0..MAXNDATA);
  key: Character;
  port: C.char_array := "/dev/ttyS2";
  fd : Integer; datalen: C.Int; count: Integer:=0; count_max: Integer:=100 ;
  range_mode: Integer:=RANGE_100; res_mode: Integer:=RES_1_DEG; unit_mode : Integer:=MMMODE;
  baud_sel: Integer := BAUD_9600;--BAUD_38400;//BAUD_19200;// BAUD_9600;
 

-- function Integer_To_int is new
--   ada.Unchecked_Conversion (Integer, C.Int);
-- function Int_To_integer is new
--   ada.Unchecked_Conversion (C.Int, Integer);
-- -- 
-- function Integer_To_size is new
--   ada.Unchecked_Conversion (Integer, C.size_t);
-- 
-- function Unsigned_To_char is new
--   ada.Unchecked_Conversion (C.Unsigned_char,Character);
-- function Double_To_Float is new
--   ada.Unchecked_Conversion (C.char,C.Unsigned_char);

begin

  put("Empieza la inicializacion: (ESPERA A QUE SE PONGA EL LED VERDE SOLO!!!!"); 
  Get_Immediate (key);

  connectToLMS(range_mode, res_mode, unit_mode, port, baud_sel);
  put_line("Fin de inicializacion");
  count_max := 100;
  while (count < count_max) loop
    datalen := readLMSValues;
    if (datalen /= 0) then
	for I in 0 .. datalen loop
		put(I);put(":");put(laserazo(I)); put(" ");
		if (( I mod 5)  = 0 ) then new_line; end if;
	end loop;
	
      count:=count + 1;
    end if;
  end loop;

  vaciarlaser;
  put_line("Vaciado el laser");
  stopLMS;
  put_line("Paramos el laser");
  resetLMS;
  put_line("Reseteamos el laser");

end test_laser_ada;

--************************************************************
--version vieja

-- begin
-- 
--   put("Empieza la inicializacion: (ESPERA A QUE SE PONGA EL LED VERDE SOLO!!!!"); 
--   Get_Immediate (key);
-- 
--   fd := connectToLMS(range_mode, res_mode, unit_mode, port, baud_sel);
--   put("Fin de inicializacion\n");
--   count_max := 100;
--   while (count < count_max) loop
--     datalen := readLMSdata(fd, buf);
--     if (datalen /= 0) then
--       showlaser(datalen,buf);
-- 
--       chkstatus(buf( C.size_t(datalen + 7) ));
--       count:=count + 1;
--     end if;
--   end loop;
-- 
--   stopLMS(fd);
--   resetLMS(fd);
-- 
-- end test_laser_ada;