#ifndef RSSI_H_
#define RSSI_H_
#include "config/compiler.h"
#include "wmp_misc.h"
typedef struct{
	char *elem;
	int initialized;
	int n_elements;
	char avgd_value;
	int idx;
	unsigned long seen;
} MobileAverage ;

void mobile_avg_init(MobileAverage * e, int n_elements);
void mobile_avg_free(MobileAverage * e);
void mobile_avg_new_value(MobileAverage*e, char val);
void mobile_avg_reset(MobileAverage* e);
char mobile_avg_get_averaged_value(MobileAverage * e);
long mobile_avg_get_age(MobileAverage * e);	

#endif /*RSSI_H_*/
