#ifndef RSSI_AVERAGE_H_
#define RSSI_AVERAGE_H_
#define RSSI_AVERAGE_ELEMENTS 10

#include "config/compiler.h"
#include "global.h"
#include "MobileAverage.h"

void initMobileAverage();
void freeMobileAverage();
void rssi_new_frame(unsigned char id, char val);
void rssi_reset(unsigned char id);
char rssi_get_averaged_rssi(unsigned char id);
char rssi_get_age(unsigned char id);


#endif /*RSSI_AVERAGE_H_*/
