#ifndef EXTENSIONS_H_
#define EXTENSIONS_H_

//#define BROADCAST 
//#define MULTIQUEUE 10

#define INIT_EXTENSIONS() INIT_BC_QUEUES ; INIT_MQUEUE ;
#define CLOSE_EXTENSIONS() CLOSE_BC_QUEUES ; CLOSE_MQUEUE ;
#define EVENT_PUSH_UC_MESSAGE(p) p


#ifdef BROADCAST
    #define INIT_BC_QUEUES init_bc_Queues()
	#define CLOSE_BC_QUEUES free_bc_Queues()
	//#define EVENT_NEW_TOKEN(t) bc_create_new_token(t)
    #define EVENT_TOKEN_RECEIVED(t) bc_token_received(t)
    #define EVENT_MESSAGE_RECEIVED(t) bc_token_received(t)
    #define EVENT_AUTHORIZATION_RECEIVED(t) bc_token_received(t)
    //#define EVENT_PREPARING_AUTH(t) bc_save_token(t);
    #include "extensions/broadcast/interface/bc_manage_broadcast.h"
    #include "extensions/broadcast/common/bc_queues.h"       
#endif 


#ifdef MULTIQUEUE
  	#include "extensions/multi_queue/mq_queues.h"
	#define INIT_MQUEUE init_mq_Queues(MULTIQUEUE)
	#define CLOSE_MQUEUE free_mq_Queues()
	#define EVENT_PUSHED_UC_MESSAGE(p) mq_event_pushed_msg(p);
#endif 




/* To get the compiler happy *********************************************************************/
#ifndef EVENT_NEW_TOKEN
#define EVENT_NEW_TOKEN
#endif 
#ifndef EVENT_TOKEN_RECEIVED
#define EVENT_TOKEN_RECEIVED
#endif 
#ifndef EVENT_PREPARING_AUTH
#define EVENT_PREPARING_AUTH
#endif 
#ifndef EVENT_MESSAGE_RECEIVED
#define EVENT_MESSAGE_RECEIVED
#endif 
#ifndef EVENT_AUTHORIZATION_RECEIVED
#define EVENT_AUTHORIZATION_RECEIVED
#endif 
#ifndef INIT_BC_QUEUES 
#define INIT_BC_QUEUES 
#endif 
#ifndef INIT_MQUEUE
#define INIT_MQUEUE
#endif 
#ifndef CLOSE_BC_QUEUES
#define CLOSE_BC_QUEUES
 #endif 
#ifndef CLOSE_MQUEUE
#define CLOSE_MQUEUE
#endif 
#ifndef EVENT_PUSHED_UC_MESSAGE
#define EVENT_PUSHED_UC_MESSAGE 
#endif 

#endif /*EXTENSIONS_H_*/

