---------------------------------------------------------------------
-- Fichero:   medir.adb
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.1 14-3-2003
-- Proposito: Medir el tiempo de computo de un proceso
---------------------------------------------------------------------
-- v2.1 14-3-2003, JDT
--   Cambiado a Ada.Real_time en lugar de Calendar
---------------------------------------------------------------------
with MaRTE_OS;
with text_io, Ada.Real_Time, acciones ;
use  text_io, Ada.Real_Time, acciones ;

procedure medir is

  package DIO is new FIXED_IO (duration) ; use DIO ;

  bucles: integer := 10 ;
  INICIO : time ;
  TIEMPO_COMPUTO : Time_Span;

begin
  INICIO := clock ;
  for I in 1..bucles loop
    null ;
    accion3 ;
  end loop ;
  TIEMPO_COMPUTO := clock - INICIO ;
  INICIO := clock ;
  for I in 1..bucles loop
    null ;
  end loop ;
  TIEMPO_COMPUTO := TIEMPO_COMPUTO + INICIO - clock ;
  put ("Tiempo de computo = ") ;
  put (To_Duration(TIEMPO_COMPUTO/bucles)) ;
  put_line (" sg.") ;
end medir;
