/*fichero de pruebas */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// #include <iostream>
// #include <libplayerc++/playerc++.h>
//includes de los drivers de marteOS
#include <../drivers/laser-marte/laser.c>
#include <drivers/laser_types.h>

#include "../drivers/p2os-marte/p2os.h"
//#include "../drivers/p2os-marte/p2os.c"



#include "imported/Matriz.h"
#include "imported/Matriz.c"

#include "imported/IntMatSM.h"
#include "imported/IntMatSM.c"

#include "imported/TData.h"

#include "imported/Laser.h"
#include "imported/Laser.c"

#include "imported/tiempo.h"
#include "imported/tiempo.c"

#include "imported/calcul.h"
#include "imported/calcul.c"

#include "KFPT.h"
#include "KFPT.c"

#include "imported/basicOp.h"

#include "imported/laserInt.h"
#include "imported/laserInt.c"

#include "imported/nd.h"
#include "imported/nd.c"

#include "imported/movimiento.h"
#include "imported/movimiento.c"

#include "imported/IntMatND.h"
#include "imported/IntMatND.c"
 
//#include "geometria.h"
//#include "IntMatND.h"
//#include "LinePl.h"


#define MAXITER 902
#define MAX_DIST 0.85
#define maxNum 361

//static float cosAng[NUMPUNTOSLASER];
//static float sinAng[NUMPUNTOSLASER];

  // Clasificacion estatico dinamico ------------
  TclassPt clasificacion;
  // Para cuando lo movamos reactivamente -------
  TCoordenadas objetivo;
  static TInfoMovimiento movimiento;
  static TInfoEntorno entorno;
  static TParametrosND NDparametros;
  TVelocidades *velo;  
  Tpf goal;
  static float mapa[DIMMATRIZ][DIMMATRIZ];

int actuador()
{
//   	using namespace PlayerCc;

  // Indices
  short i;

  float laser[NUMPUNTOSLASER]; 
//   char ptClass[NUMPUNTOSLASER];

  // Variables de varios usos -------------------
  int cnt,sLuim,res;
//   float angLinePl;
  float period;

  // el MAPA ------------------------------------

//   static float mapa[DIMMATRIZ][DIMMATRIZ];

  // Reference systems --------------------------
  Tsc Smatriz, Srobot, motion, Srobot_k1,tmp;
  
  // Some auxiliary scans -----------------------
//   Tscan movingPts, staticPts;

  // Filtros de kalman --------------------------
  TnodoKFPT *KFS, *sig;
  short numFilters;



//OJO!!!!!!!!!! 
//Se ha definido global por problemas de ejecucion-compilacion
//   // Clasificacion estatico dinamico ------------
//   TclassPt clasificacion;

  //Para medir tiempos --------------------------
 static TTiempo tiempo1, tiempo2, tiempoScan, tiempoInit;
//   float tiempoSc;

//   // Para cuando lo movamos reactivamente -------
//   TCoordenadas objetivo;
//   static TInfoMovimiento movimiento;
//   static TInfoEntorno entorno;
//   static TParametrosND NDparametros;
//   TVelocidades *velo;  
//   Tpf goal;
  
  // Variables para la lectura de laser ---------
  TSR SR2;
  TInfoLaser barrido;
  

  // Para guardar datos -------------------------
//  float laserazos[MAXITER][NUMPUNTOSLASER];
//   Tsc odometrias[MAXITER];
  Tsc odometriaKAnt;
  Tsc odometriaK;
//   float tiempos[MAXITER];
  FILE *fout;
  int output2screen=1;
  int nuuum;
  float x,y,dir;

//   int online=1;


  if (output2screen)
	  fout=stderr;
  else fout=fopen("log.out","w");
  

  // INITIALIZATIONS
  fprintf(fout,"\n ** Init phase **\n\n");

   
  cnt=0; 
  Srobot.x=0; 
  Srobot.y=0; 
  Srobot.tita=0;
  period=0;


  InitMatriz(mapa,&Smatriz,&Srobot);

  InitLaser();

  initKFPT();

	  res=InicializarLaser(LASER_REAL,SR2);
	  fprintf(fout,"Inicializando laser ... %d\n",res);

	  res=InicializarMovimiento(MOVIMIENTO_REAL,&movimiento);
	  fprintf(fout,"Inicializando movimiento ... %d\n",res);
	
  InitMatND(&NDparametros);

  InitScanMatching();

  goal.x = 0 ; 
  goal.y = 0 ;

  KFS=(TnodoKFPT *)CrearListaKFPT();
  numFilters=0;

  
  fprintf(fout,"**  Execution phase **\n");

  initKFModule(0.5, 0.5, 0.01, 0.01);
 
  ObtenerTiempo(&tiempoScan);
  tiempoInit=tiempoScan;

  //printf("pulse enter para iterar\n"); getchar();

   struct timespec ts;
  ts.tv_sec = 0;
  ts.tv_nsec = 1000*1000*100;

  while (true){ // && RAIZ( CUADRADO(goal.x-Srobot.x)+CUADRADO(goal.y-Srobot.y) )>MAX_DIST)


      		nanosleep (&ts, NULL);

//para medir la duracion de la interrupcion
struct timespec ts;
  clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts);   
  double t1=ts.tv_nsec;
// 	  	fprintf(stderr,"Goal_x=%f\tGoal_y=%f\n",goal.x,goal.y);

//ojo que aqui deberian de actualizarse los valores del laser y del p2os


	// Aqui van las llamadas a las medidas sensoriales -------------------
	//--------------------------------------------------------------------
	// Laser

		LeerBarrido(SR2,&barrido);
		LeerOdometria(0,&movimiento);	
		ObtenerTiempo(&tiempo1);
		period=(float)ObtenerIntervaloTiempos(&tiempo1,&tiempoScan) / 1000.0;	
		//fprintf(stderr,"PERIOD = %f !!\n",period);
		tiempoScan=tiempo1;
		
	
		//Este valor LONGITUD_MAXIMA_BARRIDO como "define" lo cambiaria a 
		//getCountLaser() del laser
		for (i=0; i< barrido.longitud; i++){
			laser[i]=barrido.distancia[i];
			//fprintf(stderr,"%f\t",laser[i]);
			//laserazos[cnt][i]=barrido.distancia[i];	  
		}
		//fprintf(stderr,"\n");
		// Odometria posicion	
// 		odometrias[cnt].x=movimiento.SR1.posicion.x; 
// 		odometrias[cnt].y=movimiento.SR1.posicion.y; 
// 		odometrias[cnt].tita=movimiento.SR1.orientacion;	

		odometriaK.x = movimiento.SR1.posicion.x;
		odometriaK.y = movimiento.SR1.posicion.y; 
		odometriaK.tita = movimiento.SR1.orientacion;	


		// Odometria velocidad
	//	movimiento.velocidades.v=movimiento.SR1.velocidades.v; //0.0F;
	//	movimiento.velocidades.w=movimiento.SR1.velocidades.w; //0.0F;
		movimiento.velocidades.v= movimiento.velocidades.v; //0.0F;
		movimiento.velocidades.w= movimiento.velocidades.w; //0.0F;



	// Motion from the last position
	if (cnt>0) {
		inversion_sis(&odometriaKAnt, &tmp);
		composicion_sis(&tmp,&odometriaK,&motion);		
//		inversion_sis(&odometrias[cnt-1], &tmp);
//		composicion_sis(&tmp,&odometrias[cnt],&motion);		
	}
	else {
		motion=odometriaK;
//		motion=odometrias[cnt];
	}
	odometriaKAnt = odometriaK;

	Srobot_k1=Srobot;
	composicion_sis(&Srobot_k1, &motion, &Srobot);

	
	// Predecir modelos---------------------------------------------------
	//--------------------------------------------------------------------
	ObtenerTiempo(&tiempo1);
	predictFilers(KFS, period);

	ObtenerTiempo(&tiempo2);
	sig=KFS;nuuum=0;
	while (sig!=(TnodoKFPT*) NULL){
		nuuum++;
		sig=(TnodoKFPT*) sig->next;
	}
// 	fprintf(fout, "Numm filters after prediction %d\n", nuuum);
// 	fprintf(fout,"Predecir filtros:: Tiempo Scan(mseg) = %d\n", (int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));
	
	// Clasificar puntos--------------------------------------------------
	//--------------------------------------------------------------------
	ObtenerTiempo(&tiempo1);

	for (i=0; i<100;i++)
		clasificarPuntos(laser, mapa, KFS, &Srobot, &Smatriz, &clasificacion);
// fprintf(fout, "after for\n");
	ObtenerTiempo(&tiempo2);
// 	fprintf(fout,"Clasificar puntos  :: Tiempo Scan(mseg) = %d\n", (int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));


	// Procesar la informacion Estatica -----------------------------------
	//---------------------------------------------------------------------


	ObtenerTiempo(&tiempo1);		
	sLuim=ScanMatching(mapa, &Smatriz, &clasificacion.staticPtR, &motion, &Srobot_k1,0);		
	if (sLuim) {
		composicion_sis(&Srobot_k1, &motion, &Srobot);
	}

	ObtenerTiempo(&tiempo2);
// 	fprintf(fout,"Scan %d :: Tiempo Scan(mseg) = %d\n",sLuim,(int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));
// // 	

	// Llamada al Mapping
	ObtenerTiempo(&tiempo1); 	
// 	fprintf(fout, "entro en mov matrix\n");
	MovimientoMatriz(&Srobot, &Smatriz, mapa);
// 	fprintf(fout, "after mov matrix\n");
ProyectaLaser2Matriz(mapa,&clasificacion.staticPtR, &clasificacion.movingPtR, 
		&clasificacion.unknownPtR, &clasificacion.outPtR, &Srobot, &Smatriz);
// 	fprintf(fout, "after proyecta\n");
	ObtenerTiempo(&tiempo2);
	
// 	fprintf(fout,"Mapa %d :: Tiempo Mapa(mseg) = %d\n",1,(int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));


	// Procesar la informacion Dinamica -----------------------------------
	//---------------------------------------------------------------------		
	ObtenerTiempo(&tiempo1); 	
	updateFilters(&KFS, &clasificacion.movingPtR, &Srobot);

	sig=KFS;nuuum=0;
	while (sig!= (TnodoKFPT*) NULL){
		nuuum++;
		sig=(TnodoKFPT*) sig->next;
	}
// 	fprintf(fout, "Numm filters after update %d\n", nuuum);


	ObtenerTiempo(&tiempo1); 	
// 	fprintf(fout,"Update filters :: Tiempo Mapa(mseg) = %d\n",(int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));

// 	fprintf(fout,"------------------------------------\n");



// 	Llamada al ND

	if (KFS== (TnodoKFPT*) NULL){
// 		fprintf(stderr,"KFS== (TnodoKFPT*) NULL\n");
		goal.x=Srobot.x;
		goal.x=Srobot.y;
	}
	else {
		x=KFS->filter.x.data[0];
		y=KFS->filter.x.data[1];
		dir=atan2((Srobot.y-y),(Srobot.x-x));
		goal.x=x+cos(dir);
		goal.y=y+sin(dir);
	}

	ObtenerTiempo(&tiempo1);
// 	if (plan && RAIZ( CUADRADO(goal.x-Srobot.x)+CUADRADO(goal.y-Srobot.y) )>MAX_DIST ){  
// 		transfor_directa_p(cos(angLinePl),sin(angLinePl),&Srobot,&sol);
// 		objetivo.x=sol.x;  objetivo.y=sol.y; }
// 	else{	
// 	
	objetivo.x=goal.x; objetivo.y=goal.y;

	ComputaMapa( mapa, &Smatriz, &Srobot, &entorno, &clasificacion.robotScan); // Nube de puntos para ND

	movimiento.SR1.posicion.x=Srobot.x;
	movimiento.SR1.posicion.y=Srobot.y;
	movimiento.SR1.orientacion=Srobot.tita;

// 	fprintf(fout,"x_obj:%f, y_obj:%f\n",goal.x,goal.y);
	velo = IterarND(objetivo,
					&movimiento,
					&entorno,
					NULL);

	ObtenerTiempo(&tiempo2);	
	if (velo==NULL){

		OrdenarParada();
// 		fprintf(fout,"ND++ 1 :: Tiempo ND++(mseg) = %d\n-- Parada de emergencia!!\n",(int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2));
	}
	else {	
// 		fprintf(fout,"ND++ 1 :: Tiempo ND++(mseg) = %d\n-- <v,w> = <%f,%f>\n",(int)ObtenerIntervaloTiempos(&tiempo1,&tiempo2),velo->v,velo->w);	
		res=EstablecerConsigna(*velo);
	}

// 	fprintf(fout,"Comando enviado ... %d\n", res);


//     fprintf(fout,"Next Iteration %d \n",cnt);
    cnt++;
	//fflush(fout);
	


  clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts);
  
  double t2=ts.tv_nsec;
  //printf(">>>>>>> %.6lf   nseconds elapsed\n", t2-t1);
  };

  FinalizarLaser();
  FinalizarMovimiento();

return 0;
}

