-- Proposito: Medir el tiempo de computo de un proceso


with text_io, Ada.Real_Time;
use  text_io, Ada.Real_Time;

--*************************************************
-- DEL LASER
with Ada.Unchecked_Conversion;
with Ada.Integer_Text_IO;     use Ada.Integer_Text_IO;
with Ada.Float_Text_IO;     use Ada.Float_Text_IO;

with MaRTE_OS;
with p2os_import; use p2os_import;

with Interfaces.C;
--*************************************************
--*************************************************
with POSIX;
with POSIX_Timers;
pragma Elaborate_All (POSIX_Timers);


procedure medir is


--*************************************************
-- DEL LASER
package C renames Interfaces.C;
          use type C.char_array;
	  use type C.unsigned_char;

  --buf: C.char_array(0..MAXNDATA);
  key: Character;
  port: C.char_array := "/dev/ttyS0";
  var : C.Int;
  varUC: C.unsigned_char;
  varUS: C.unsigned_short;
  varS: C.short;
--   datalen: C.Int; count: Integer:=0; count_max: Integer:=100 ;
--   range_mode: Integer:=RANGE_100; res_mode: Integer:=RES_1_DEG; unit_mode : Integer:=MMMODE;
--   baud_sel: Integer := BAUD_9600;--BAUD_38400;//BAUD_19200;// BAUD_9600;

  valor:C.Int;
--*************************************************

  package DIO is new FIXED_IO (duration) ; use DIO ;

  bucles: integer := 1;
  INICIO : time ;
  TIEMPO_COMPUTO : Time_Span;

   timer : POSIX_Timers.Timer_Id;
   CPU_Time_First : POSIX.Timespec := POSIX.To_Timespec (0.0);
   CPU_Time_Last : POSIX.Timespec := POSIX.To_Timespec (0.0);

begin
--*************************************************
-- DEL LASER
  put("Inicializo p2os. Pulsa una tecla"); 
  Get_Immediate (key);

 var:=initP2os(port);
  put("Fin de inicializacion");new_line;
  
  --p2osGetValues;

for I in 1 .. 10 loop
  CPU_Time_First := POSIX_Timers.Get_Time(POSIX_Timers.Clock_Task_Cputime_Id);
  p2osGetValues;
  CPU_Time_Last := POSIX_Timers.Get_Time(POSIX_Timers.Clock_Task_Cputime_Id);
  put("Tiempo = "); put ((POSIX.To_Duration (CPU_Time_Last) - POSIX.To_Duration (CPU_Time_First)) * 1000); 
  put_line("ms.");
end loop;
-- -- Medimos el tiempo de computo de la operacion laserazo
--   INICIO := clock ;
--   for I in 1..bucles loop
--     null ;
--     -- poner la accion que sea
--         var:=p2osGetXpos;
--   end loop ;
--   TIEMPO_COMPUTO := clock - INICIO ;
--   INICIO := clock ;
--   for I in 1..bucles loop
--      null ;
--   end loop ;
--   TIEMPO_COMPUTO := TIEMPO_COMPUTO + INICIO - clock ;
--   put ("Tiempo de computo = ") ;
--   put (To_Duration(TIEMPO_COMPUTO/bucles)*1000) ;
--   put_line (" ms.") ;

-- Del P2OS

  var:=p2osShutdown;
--*************************************************
end medir;
