-- Proposito: Medir el tiempo de computo de un proceso

with MaRTE_OS;
with system;
with text_io, Ada.Real_Time;
use  text_io, Ada.Real_Time;
with Ada.Dynamic_Priorities;
use Ada.Dynamic_Priorities;
--*************************************************
-- DEL LASER
with Ada.Unchecked_Conversion;
with Ada.Integer_Text_IO;     use Ada.Integer_Text_IO;
with Ada.Float_Text_IO;     use Ada.Float_Text_IO;


with laser_import; use laser_import;
with Interfaces.C;
--*************************************************


procedure medir_readLMSValues2tareas is



  package DIO is new FIXED_IO (duration) ; use DIO ;

  bucles: integer := 5 ;
  INICIO : time ;
  TIEMPO_COMPUTO : Time_Span;
  laser_priority : constant System.Any_Priority := 19;
  calculos_priority : constant System.Any_Priority := 17;



--*************************************************
-- DEL LASER
package C renames Interfaces.C;
          use type C.char_array;
	  use type C.unsigned_char;

--   buf: C.char_array(0..MAXNDATA);
  key: Character;
  port: C.char_array := "/dev/ttyS2";
  count: Integer:=0; count_max: Integer:=100 ;
  range_mode: Integer:=RANGE_180; res_mode: Integer:=RES_0_5_DEG; unit_mode : Integer:=MMMODE;
  baud_sel: Integer := BAUD_9600;--BAUD_38400;//BAUD_19200;// BAUD_9600;
--*************************************************


procedure principal is

salida: boolean:=false;


 --******************************************************
--TAREA DEL LASER
task tarea_laser is
     pragma Priority (laser_priority);
end tarea_laser;


task body tarea_laser is
datalen: C.Int;

begin

   
INICIO := clock ;
  for I in 1..bucles loop
        -- poner la accion que sea
     datalen := readLMSValues;
  end loop ;
  TIEMPO_COMPUTO := clock - INICIO ;
  INICIO := clock ;
  for I in 1..bucles loop
     null ;
  end loop ;
  TIEMPO_COMPUTO := TIEMPO_COMPUTO + INICIO - clock ;
  put ("Tiempo de computo = ") ;
  put (To_Duration(TIEMPO_COMPUTO/bucles)*1000) ;
  put_line (" ms.") ;
	
--    end loop;
   
 salida := true;
end tarea_laser;


-- task tarea_calculos is
--    pragma Priority (calculos_priority);
-- end tarea_calculos;
-- 
-- task body tarea_calculos is
-- var1,var2:Float;
-- begin
--  loop
-- 
--  var1 := 0.0;
--  var2:= 0.0;
-- -- loop
-- 
-- INICIO := clock ;
--   for I in 1..bucles loop
--         -- poner la accion que sea
--      for I in 1 .. 1000000 loop
-- 	var1 := ((var1+1.0)*100.0 )/(var2+0.1);
--     end loop; 
--   end loop ;
--   TIEMPO_COMPUTO := clock - INICIO ;
--   INICIO := clock ;
--   for I in 1..bucles loop
--      null ;
--   end loop ;
--   TIEMPO_COMPUTO := TIEMPO_COMPUTO + INICIO - clock ;
--   put ("Tiempo de computo = ") ;
--   put (To_Duration(TIEMPO_COMPUTO/bucles)*1000) ;
--   put_line (" ms.") ;
-- 
-- 
-- --         salida := true;
-- -- 	if salida = true then
-- -- 		salida2 := true;
--    end loop;
--  
-- end tarea_calculos;

   begin
      -- Hasta que salida no es true el sistema sigue funcionando
       while not salida loop
          null;
       end loop;
 	abort tarea_laser;
-- 	abort  tarea_calculos;
--  	abort tarea_laser,tarea_calculos;
--null;
end principal;


begin

-- put("Dale al enter para lanzar las tareas");
-- Skip_line;
--*************************************************
-- DEL LASER
  put_line("Empieza la inicializacion: (ESPERA A QUE SE PONGA EL LED VERDE SOLO!!!!"); 
  Get_Immediate (key);

  connectToLMS(range_mode, res_mode, unit_mode, port, baud_sel);
  put("Fin de inicializacion");new_line;
  --Get_Immediate (key);
-- Medimos el tiempo de computo de la operacion readLMSValues


put_line("Lanzo principal");
principal;
put_line("Se sale del programa");
-- --*************************************************
-- -- DEL LASER
-- vaciarLaser;
  stopLMS;
  resetLMS;
-- --*************************************************
end medir_readLMSValues2tareas;
