#ifndef QUEUES_H_
#define QUEUES_H_
#include "core/interface/Msg.h"
#include "common/include/Queue.h"
#include <string.h>

void initQueues();
void freeQueues();
void pushRcvdUCMsg(Msg * p);
long popUCMsgToSend(Msg * p);
int getNumOfElementInRXUCQueue();
int getNumOfElementInTXUCQueue();
int getNumOfFreePositionsInTXUCQueue();
int getHighestPriorityInTxUCQueue();
int getHighestPriorityAgeInTxUCQueue();

#endif /*QUEUES_H_*/


